# coding: utf-8

"""
    BIMData API

    BIMData API is a tool to interact with your models stored on BIMData’s servers.     Through the API, you can manage your projects, the clouds, upload your IFC files and manage them through endpoints.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: support@bimdata.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from bimdata_api_client.configuration import Configuration


class TopicStatus(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'topic_status': 'str',
        'color': 'str',
        'project': 'int'
    }

    attribute_map = {
        'id': 'id',
        'topic_status': 'topic_status',
        'color': 'color',
        'project': 'project'
    }

    def __init__(self, id=None, topic_status=None, color=None, project=None, local_vars_configuration=None):  # noqa: E501
        """TopicStatus - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._topic_status = None
        self._color = None
        self._project = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.topic_status = topic_status
        self.color = color
        if project is not None:
            self.project = project

    @property
    def id(self):
        """Gets the id of this TopicStatus.  # noqa: E501


        :return: The id of this TopicStatus.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TopicStatus.


        :param id: The id of this TopicStatus.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def topic_status(self):
        """Gets the topic_status of this TopicStatus.  # noqa: E501


        :return: The topic_status of this TopicStatus.  # noqa: E501
        :rtype: str
        """
        return self._topic_status

    @topic_status.setter
    def topic_status(self, topic_status):
        """Sets the topic_status of this TopicStatus.


        :param topic_status: The topic_status of this TopicStatus.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and topic_status is None:  # noqa: E501
            raise ValueError("Invalid value for `topic_status`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                topic_status is not None and len(topic_status) > 255):
            raise ValueError("Invalid value for `topic_status`, length must be less than or equal to `255`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                topic_status is not None and len(topic_status) < 1):
            raise ValueError("Invalid value for `topic_status`, length must be greater than or equal to `1`")  # noqa: E501

        self._topic_status = topic_status

    @property
    def color(self):
        """Gets the color of this TopicStatus.  # noqa: E501


        :return: The color of this TopicStatus.  # noqa: E501
        :rtype: str
        """
        return self._color

    @color.setter
    def color(self, color):
        """Sets the color of this TopicStatus.


        :param color: The color of this TopicStatus.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                color is not None and len(color) > 8):
            raise ValueError("Invalid value for `color`, length must be less than or equal to `8`")  # noqa: E501

        self._color = color

    @property
    def project(self):
        """Gets the project of this TopicStatus.  # noqa: E501

        This field is automatically provided by the route, you don't need to provide it in the body  # noqa: E501

        :return: The project of this TopicStatus.  # noqa: E501
        :rtype: int
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this TopicStatus.

        This field is automatically provided by the route, you don't need to provide it in the body  # noqa: E501

        :param project: The project of this TopicStatus.  # noqa: E501
        :type: int
        """

        self._project = project

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TopicStatus):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TopicStatus):
            return True

        return self.to_dict() != other.to_dict()
